diff --git a/nptl/tst-basic1.c b/nptl/tst-basic1.c
index 8ea4523..144aaf6 100644
--- a/nptl/tst-basic1.c
+++ b/nptl/tst-basic1.c
@@ -22,6 +22,11 @@
 #include <sys/types.h>
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static pid_t pid;
 
 static void *
@@ -29,7 +34,7 @@ tf (void *a)
 {
   if (getpid () != pid)
     {
-      write (2, "pid mismatch\n", 13);
+      write_message_to_stderr ("pid mismatch\n");
       _exit (1);
     }
 
@@ -49,7 +54,7 @@ do_test (void)
   for (i = 0; i < N; ++i)
     if (pthread_create (&t[i], NULL, tf, (void *) (long int) (i + 1)) != 0)
       {
-	write (2, "create failed\n", 14);
+	write_message_to_stderr ("create failed\n");
 	_exit (1);
       }
     else
@@ -66,7 +71,7 @@ do_test (void)
 	}
       else if (r != (void *) (long int) (i + 1))
 	{
-	  write (2, "result wrong\n", 13);
+	  write_message_to_stderr ("result wrong\n");
 	  _exit (1);
 	}
       else
@@ -75,7 +80,3 @@ do_test (void)
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-cleanup1.c b/nptl/tst-cleanup1.c
index 82a568b..bca057a 100644
--- a/nptl/tst-cleanup1.c
+++ b/nptl/tst-cleanup1.c
@@ -22,6 +22,11 @@
 #include <unistd.h>
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static int global;
 
 
@@ -67,7 +72,7 @@ do_test (void)
 
   if (pthread_create (&th, NULL, tf, NULL) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
@@ -93,7 +98,3 @@ do_test (void)
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-cleanup3.c b/nptl/tst-cleanup3.c
index 3c34a1e..da20f28 100644
--- a/nptl/tst-cleanup3.c
+++ b/nptl/tst-cleanup3.c
@@ -22,6 +22,11 @@
 #include <unistd.h>
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static int global;
 
 
@@ -65,7 +70,7 @@ do_test (void)
 
   if (pthread_create (&th, NULL, tf, NULL) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
@@ -91,7 +96,3 @@ do_test (void)
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-key1.c b/nptl/tst-key1.c
index 0ed1787..a3ab5bf 100644
--- a/nptl/tst-key1.c
+++ b/nptl/tst-key1.c
@@ -23,6 +23,11 @@
 #include <unistd.h>
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 int
 do_test (void)
 {
@@ -38,7 +43,7 @@ do_test (void)
   for (i = 0; i < max; ++i)
     if (pthread_key_create (&keys[i], NULL) != 0)
       {
-	write (2, "key_create failed\n", 18);
+	write_message_to_stderr ("key_create failed\n");
 	_exit (1);
       }
     else
@@ -82,7 +87,3 @@ do_test (void)
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-key2.c b/nptl/tst-key2.c
index 3142c86..bdf17fe 100644
--- a/nptl/tst-key2.c
+++ b/nptl/tst-key2.c
@@ -23,6 +23,11 @@
 #define N 2
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static int cnt0;
 static void
 f0 (void *p)
@@ -53,7 +58,7 @@ tf (void *arg)
 
   if (pthread_setspecific (*key, (void *) -1l) != 0)
     {
-      write (2, "setspecific failed\n", 19);
+      write_message_to_stderr ("setspecific failed\n");
       _exit (1);
     }
 
@@ -70,45 +75,41 @@ do_test (void)
   for (i = 0; i < N; ++i)
     if (pthread_key_create (&keys[i], fcts[i]) != 0)
       {
-	write (2, "key_create failed\n", 18);
+	write_message_to_stderr ("key_create failed\n");
 	_exit (1);
       }
 
   pthread_t th;
   if (pthread_create (&th, NULL, tf, &keys[1]) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
   if (pthread_join (th, NULL) != 0)
     {
-      write (2, "join failed\n", 12);
+      write_message_to_stderr ("join failed\n");
       _exit (1);
     }
 
   if (cnt0 != 0)
     {
-      write (2, "cnt0 != 0\n", 10);
+      write_message_to_stderr ("cnt0 != 0\n");
       _exit (1);
     }
 
   if (cnt1 != 1)
     {
-      write (2, "cnt1 != 1\n", 10);
+      write_message_to_stderr ("cnt1 != 1\n");
       _exit (1);
     }
 
   for (i = 0; i < N; ++i)
     if (pthread_key_delete (keys[i]) != 0)
       {
-	write (2, "key_delete failed\n", 18);
+	write_message_to_stderr ("key_delete failed\n");
 	_exit (1);
       }
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-key3.c b/nptl/tst-key3.c
index a298569..24156a4 100644
--- a/nptl/tst-key3.c
+++ b/nptl/tst-key3.c
@@ -23,6 +23,11 @@
 #define N 2
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static int cnt0;
 static void
 f0 (void *p)
@@ -56,7 +61,7 @@ tf (void *arg)
 
   if (pthread_setspecific (*key, (void *) -1l) != 0)
     {
-      write (2, "setspecific failed\n", 19);
+      write_message_to_stderr ("setspecific failed\n");
       _exit (1);
     }
 
@@ -80,20 +85,20 @@ do_test (void)
   for (i = 0; i < N; ++i)
     if (pthread_key_create (&keys[i], fcts[i]) != 0)
       {
-	write (2, "key_create failed\n", 18);
+	write_message_to_stderr ("key_create failed\n");
 	_exit (1);
       }
 
   if (pthread_barrier_init (&b, NULL, 2) != 0)
     {
-      write (2, "barrier_init failed\n", 20);
+      write_message_to_stderr ("barrier_init failed\n");
       _exit (1);
     }
 
   pthread_t th;
   if (pthread_create (&th, NULL, tf, &keys[1]) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
@@ -101,20 +106,20 @@ do_test (void)
 
   if (pthread_cancel (th) != 0)
     {
-      write (2, "cancel failed\n", 14);
+      write_message_to_stderr ("cancel failed\n");
       _exit (1);
     }
 
   void *status;
   if (pthread_join (th, &status) != 0)
     {
-      write (2, "join failed\n", 12);
+      write_message_to_stderr ("join failed\n");
       _exit (1);
     }
 
   if (status != PTHREAD_CANCELED)
     {
-      write (2, "thread not canceled\n", 20);
+      write_message_to_stderr ("thread not canceled\n");
       _exit (1);
     }
 
@@ -124,32 +129,28 @@ do_test (void)
      have run and therefore these tests succeed.  */
   if (cnt0 != 0)
     {
-      write (2, "cnt0 != 0\n", 10);
+      write_message_to_stderr ("cnt0 != 0\n");
       _exit (1);
     }
 
   if (cnt1 != 1)
     {
-      write (2, "cnt1 != 1\n", 10);
+      write_message_to_stderr ("cnt1 != 1\n");
       _exit (1);
     }
 
   for (i = 0; i < N; ++i)
     if (pthread_key_delete (keys[i]) != 0)
       {
-	write (2, "key_delete failed\n", 18);
+	write_message_to_stderr ("key_delete failed\n");
 	_exit (1);
       }
 
   if (pthread_barrier_destroy (&b) != 0)
     {
-      write (2, "barrier_destroy failed\n", 23);
+      write_message_to_stderr ("barrier_destroy failed\n");
       _exit (1);
     }
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/nptl/tst-stdio1.c b/nptl/tst-stdio1.c
index 4250e53..e9b9f18 100644
--- a/nptl/tst-stdio1.c
+++ b/nptl/tst-stdio1.c
@@ -43,7 +43,7 @@ do_test (void)
 
   if (pthread_create (&th, NULL, tf, NULL) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
diff --git a/nptl/tst-stdio2.c b/nptl/tst-stdio2.c
index 6168d27..910c13c 100644
--- a/nptl/tst-stdio2.c
+++ b/nptl/tst-stdio2.c
@@ -23,6 +23,11 @@
 #include <unistd.h>
 
 
+static int do_test (void);
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"
+
 static void *tf (void *a)
 {
   puts ("start tf");
@@ -55,7 +60,7 @@ do_test (void)
 
   if (pthread_create (&th, NULL, tf, NULL) != 0)
     {
-      write (2, "create failed\n", 14);
+      write_message_to_stderr ("create failed\n");
       _exit (1);
     }
 
@@ -75,7 +80,3 @@ do_test (void)
 
   return 0;
 }
-
-
-#define TEST_FUNCTION do_test ()
-#include "../test-skeleton.c"
diff --git a/test-skeleton.c b/test-skeleton.c
index 55841fb..803da2a 100644
--- a/test-skeleton.c
+++ b/test-skeleton.c
@@ -148,6 +148,15 @@ xasprintf (const char *format, ...)
   return result;
 }
 
+/* Write a message to standard error.  Can be used in signal handlers.  */
+static void
+__attribute__ ((unused))
+write_message_to_stderr (const char *message)
+{
+  ssize_t unused __attribute__ ((unused));
+  unused = write (STDERR_FILENO, message, strlen (message));
+}
+
 /* Write a message to standard output.  Can be used in signal
    handlers.  */
 static void